//+------------------------------------------------------------------+
//|                                   Copyright  2010, Ivan Kornilov|
//|                                                    MaKornilov.mq4|
//|                                   excelf@gmail.com, skype: excelf|
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 CadetBlue
#property indicator_color2 Red

extern int ma      = 13;
extern int signal  = 6;
extern int degree  = 1;//1,2,3
extern int price   = 0;
extern int history = 1000;

double SignalBuffer1[];
double SignalBuffer2[];
double TempBuffer[];


#include <constants.mqh>
#include <switch.mqh>
#include <indicators\indiUtils.mqh>
#include <indicators\objects.mqh>
#include <indicators\MA.mqh>
#include <indicators\Regression.mqh>


int init(){
   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_LINE, EMPTY, 1);
   SetIndexStyle(1, DRAW_LINE, EMPTY, 1);

   IndicatorDigits(Digits + 1);

   SetIndexBuffer(0, SignalBuffer1);
   SetIndexBuffer(1, SignalBuffer2);
   SetIndexBuffer(2, TempBuffer);

   IndicatorShortName("MaKornilov(" + ma + "," + signal + ")");
   SetIndexLabel(0, "SignalBuffer1");
   SetIndexLabel(1, "SignalBuffer2");
   SetIndexLabel(2, "TempBuffer");
   
   objects.initArrawObjects();
}

int start(){
   int countedBars = IndicatorCounted();
   if(countedBars > 0) {
       countedBars--;
   }
   int limit = MathMin(Bars - countedBars -1, history);

   for(int shift = limit; shift >= 0; shift--) {
      TempBuffer[shift] = regression.getRegression(ma, degree, price, shift);
      SignalBuffer2[shift] = ma.getMaByMaValue(SignalBuffer1[shift], ma, signal, 0, shift);
   } 
   
   for(shift = limit; shift >= 0; shift--) {
      SignalBuffer1[shift] = 2 * TempBuffer[shift] - iMAOnArray(TempBuffer, 0, ma, 0, 0, shift);
   } 
   
   for(shift = limit; shift >= 0; shift--) {
      SignalBuffer2[shift] = iMAOnArray(SignalBuffer1, 0, signal, 0, 0, shift);
      if(objects.drowArrow) {
         if(SignalBuffer1[shift] < SignalBuffer2[shift] && SignalBuffer1[shift + 1] > SignalBuffer2[shift + 1]) {
             objects.addPointArrow(-1, shift);
         } else if(SignalBuffer1[shift] > SignalBuffer2[shift] && SignalBuffer1[shift + 1] < SignalBuffer2[shift + 1]) {
             objects.addPointArrow(1, shift);
         }     
      } 
   }
}

int deinit() {
   objects.deinitArrawObjects();
}

